import { Vector } from './vector.js';
export declare abstract class AbstractNode {
    id: string;
    left: number;
    right: number;
    top: number;
    bottom: number;
    get width(): number;
    get height(): number;
    get centerX(): number;
    get centerY(): number;
    protected root: Element;
    constructor(nodeXML: Element);
    generateBoundingBox(): Vector[];
    abstract render(svg: SVGSVGElement, offsetX: number, offsetY: number): any;
    protected handleLabel(svg: SVGGElement): void;
    setDimensions(svgNode: SVGGElement | SVGSVGElement | SVGTextElement | SVGRectElement): void;
    setPosition(svgNode: SVGSVGElement | SVGTextElement | SVGGElement, offsetX: number, offsetY: number): void;
}
//# sourceMappingURL=abstract_node.d.ts.map